__ __ __ __ _____ _ _ _____ _ _ _ | \/ | \ \ / / | __ \ (_) | | / ____| | | | | | \ / |_ __\ V / | |__) | __ ___ ____ _| |_ ___ | (___ | |__ ___| | | | |\/| | '__|> < | ___/ '__| \ \ / / _` | __/ _ \ \___ \| '_ \ / _ \ | | | | | | |_ / . \ | | | | | |\ V / (_| | || __/ ____) | | | | __/ | | |_| |_|_(_)_/ \_\ |_| |_| |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1 if you need WebShell for Seo everyday contact me on Telegram Telegram Address : @jackleetFor_More_Tools:
#!/bin/bash
# perf stat JSON output linter
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
# Checks various perf stat JSON output commands for the
# correct number of fields.
set -e
skip_test=0
shelldir=$(dirname "$0")
# shellcheck source=lib/setup_python.sh
. "${shelldir}"/lib/setup_python.sh
pythonchecker=$(dirname $0)/lib/perf_json_output_lint.py
stat_output=$(mktemp /tmp/__perf_test.stat_output.json.XXXXX)
cleanup() {
rm -f "${stat_output}"
trap - EXIT TERM INT
}
trap_cleanup() {
cleanup
exit 1
}
trap trap_cleanup EXIT TERM INT
# Return true if perf_event_paranoid is > $1 and not running as root.
function ParanoidAndNotRoot()
{
[ "$(id -u)" != 0 ] && [ "$(cat /proc/sys/kernel/perf_event_paranoid)" -gt $1 ]
}
check_no_args()
{
echo -n "Checking json output: no args "
perf stat -j -o "${stat_output}" true
$PYTHON $pythonchecker --no-args --file "${stat_output}"
echo "[Success]"
}
check_system_wide()
{
echo -n "Checking json output: system wide "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j -a -o "${stat_output}" true
$PYTHON $pythonchecker --system-wide --file "${stat_output}"
echo "[Success]"
}
check_system_wide_no_aggr()
{
echo -n "Checking json output: system wide no aggregation "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j -A -a --no-merge -o "${stat_output}" true
$PYTHON $pythonchecker --system-wide-no-aggr --file "${stat_output}"
echo "[Success]"
}
check_interval()
{
echo -n "Checking json output: interval "
perf stat -j -I 1000 -o "${stat_output}" true
$PYTHON $pythonchecker --interval --file "${stat_output}"
echo "[Success]"
}
check_event()
{
echo -n "Checking json output: event "
perf stat -j -e cpu-clock -o "${stat_output}" true
$PYTHON $pythonchecker --event --file "${stat_output}"
echo "[Success]"
}
check_per_core()
{
echo -n "Checking json output: per core "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-core -a -o "${stat_output}" true
$PYTHON $pythonchecker --per-core --file "${stat_output}"
echo "[Success]"
}
check_per_thread()
{
echo -n "Checking json output: per thread "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-thread -p $$ -o "${stat_output}" true
$PYTHON $pythonchecker --per-thread --file "${stat_output}"
echo "[Success]"
}
check_per_cache_instance()
{
echo -n "Checking json output: per cache_instance "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-cache -a true 2>&1 | $PYTHON $pythonchecker --per-cache
echo "[Success]"
}
check_per_cluster()
{
echo -n "Checking json output: per cluster "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-cluster -a true 2>&1 | $PYTHON $pythonchecker --per-cluster
echo "[Success]"
}
check_per_die()
{
echo -n "Checking json output: per die "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-die -a -o "${stat_output}" true
$PYTHON $pythonchecker --per-die --file "${stat_output}"
echo "[Success]"
}
check_per_node()
{
echo -n "Checking json output: per node "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-node -a -o "${stat_output}" true
$PYTHON $pythonchecker --per-node --file "${stat_output}"
echo "[Success]"
}
check_per_socket()
{
echo -n "Checking json output: per socket "
if ParanoidAndNotRoot 0
then
echo "[Skip] paranoia and not root"
return
fi
perf stat -j --per-socket -a -o "${stat_output}" true
$PYTHON $pythonchecker --per-socket --file "${stat_output}"
echo "[Success]"
}
# The perf stat options for per-socket, per-core, per-die
# and -A ( no_aggr mode ) uses the info fetched from this
# directory: "/sys/devices/system/cpu/cpu*/topology". For
# example, socket value is fetched from "physical_package_id"
# file in topology directory.
# Reference: cpu__get_topology_int in util/cpumap.c
# If the platform doesn't expose topology information, values
# will be set to -1. For example, incase of pSeries platform
# of powerpc, value for "physical_package_id" is restricted
# and set to -1. Check here validates the socket-id read from
# topology file before proceeding further
FILE_LOC="/sys/devices/system/cpu/cpu*/topology/"
FILE_NAME="physical_package_id"
check_for_topology()
{
if ! ParanoidAndNotRoot 0
then
socket_file=`ls $FILE_LOC/$FILE_NAME | head -n 1`
[ -z $socket_file ] && return 0
socket_id=`cat $socket_file`
[ $socket_id == -1 ] && skip_test=1
return 0
fi
}
check_for_topology
check_no_args
check_system_wide
check_interval
check_event
check_per_thread
check_per_node
if [ $skip_test -ne 1 ]
then
check_system_wide_no_aggr
check_per_core
check_per_cache_instance
check_per_cluster
check_per_die
check_per_socket
else
echo "[Skip] Skipping tests for system_wide_no_aggr, per_core, per_die and per_socket since socket id exposed via topology is invalid"
fi
cleanup
exit 0
| Name | Type | Size | Permission | Actions |
|---|---|---|---|---|
| base_probe | Folder | 0755 |
|
|
| base_report | Folder | 0755 |
|
|
| common | Folder | 0755 |
|
|
| coresight | Folder | 0755 |
|
|
| lib | Folder | 0755 |
|
|
| annotate.sh | File | 2.08 KB | 0755 |
|
| attr.sh | File | 385 B | 0755 |
|
| buildid.sh | File | 4.15 KB | 0755 |
|
| daemon.sh | File | 11.31 KB | 0755 |
|
| diff.sh | File | 1.93 KB | 0755 |
|
| ftrace.sh | File | 2.22 KB | 0755 |
|
| list.sh | File | 756 B | 0755 |
|
| lock_contention.sh | File | 8.9 KB | 0755 |
|
| perftool-testsuite_probe.sh | File | 575 B | 0755 |
|
| perftool-testsuite_report.sh | File | 578 B | 0755 |
|
| pipe_test.sh | File | 3.22 KB | 0755 |
|
| probe_vfs_getname.sh | File | 440 B | 0755 |
|
| record+probe_libc_inet_pton.sh | File | 3.43 KB | 0755 |
|
| record+script_probe_vfs_getname.sh | File | 1.53 KB | 0755 |
|
| record+zstd_comp_decomp.sh | File | 1.12 KB | 0755 |
|
| record.sh | File | 8.27 KB | 0755 |
|
| record_bpf_filter.sh | File | 4.37 KB | 0755 |
|
| record_lbr.sh | File | 3.46 KB | 0755 |
|
| record_offcpu.sh | File | 2.07 KB | 0755 |
|
| record_sideband.sh | File | 1.07 KB | 0755 |
|
| script.sh | File | 2.01 KB | 0755 |
|
| stat+csv_output.sh | File | 2 KB | 0755 |
|
| stat+csv_summary.sh | File | 611 B | 0755 |
|
| stat+json_output.sh | File | 5.02 KB | 0755 |
|
| stat+shadow_stat.sh | File | 2.08 KB | 0755 |
|
| stat+std_output.sh | File | 2.96 KB | 0755 |
|
| stat.sh | File | 6.36 KB | 0755 |
|
| stat_all_metricgroups.sh | File | 1016 B | 0755 |
|
| stat_all_metrics.sh | File | 1.83 KB | 0755 |
|
| stat_all_pfm.sh | File | 1.17 KB | 0755 |
|
| stat_all_pmu.sh | File | 1.73 KB | 0755 |
|
| stat_bpf_counters.sh | File | 2 KB | 0755 |
|
| stat_bpf_counters_cgrp.sh | File | 1.66 KB | 0755 |
|
| stat_metrics_values.sh | File | 844 B | 0755 |
|
| test_arm_callgraph_fp.sh | File | 1.18 KB | 0755 |
|
| test_arm_coresight.sh | File | 5.7 KB | 0755 |
|
| test_arm_coresight_disasm.sh | File | 1.97 KB | 0755 |
|
| test_arm_spe.sh | File | 3.71 KB | 0755 |
|
| test_arm_spe_fork.sh | File | 1.03 KB | 0755 |
|
| test_brstack.sh | File | 2.97 KB | 0755 |
|
| test_data_symbol.sh | File | 1.95 KB | 0755 |
|
| test_intel_pt.sh | File | 17.2 KB | 0755 |
|
| test_java_symbol.sh | File | 1.96 KB | 0755 |
|
| test_perf_data_converter_json.sh | File | 1.32 KB | 0755 |
|
| test_stat_intel_tpebs.sh | File | 848 B | 0755 |
|
| test_task_analyzer.sh | File | 4.8 KB | 0755 |
|
| test_uprobe_from_different_cu.sh | File | 1.63 KB | 0755 |
|
| trace+probe_vfs_getname.sh | File | 1.45 KB | 0755 |
|
| trace_btf_enum.sh | File | 1.35 KB | 0755 |
|
| trace_btf_general.sh | File | 2.03 KB | 0755 |
|
| trace_exit_race.sh | File | 1.22 KB | 0755 |
|